#define SERIAL "/dev/ttyS0"
#define PORT 4466

#define SERVER_TIME_OUT_SELECT_SECONDS  0
#define SERVER_TIME_OUT_SELECT_USECONDS 0
#define PERIOD_POLL_CM11A 200000
#define TIMEOUT_READ_CM11A 10000000
#define BUFLEN 1520
#define MAXSOCKETS 32
#define MAXEVENTS 256
#define MAXMODULES 258

#define TOGGLE 1
#define DIM 2
#define BRIGHT 3

#define SCHED_NEVER 0
#define SCHED_PROC 1
#define SCHED_ONCE 2
#define SCHED_DAILY 3
#define SCHED_WEEKDAY 4
#define SCHED_WEEKEND 5
#define SCHED_WEEKLY 6

#define TRUE 1
#define FALSE 0

#define BADARGS(nl,nh,example) \
	if ((argc<(nl)) || (argc>(nh))) { \
	Tcl_AppendResult(irp,"wrong # args: should be \"",argv[0], \
		(example),"\"",NULL); \
		return TCL_ERROR; \
	}

#define BADMODULE(module) \
	Tcl_AppendResult(irp,"Invalid module or alias: ", module, NULL); \
	return TCL_ERROR;

/* main.c */

char *asciitime(const time_t * timep);
void camera_group_off(int module_id, struct x10_status_t *status);
int getmodule(char *module_id);
int gethouse(char *module_id);
char *cmd2string(int command);
int string2cmd(char *command);
char *status2string(int status);
int string2status(char *status);
int insert_event(int seconds, int mode, int once, int thread, int quiet, int repeat, char *script);
void fatal_error(char *msg);
char * nexttok (void);

/* tcl.c */

void x10_tcl_init(void);

/* time.c */

int sunshine(long double latitude, long double longitude, time_t the_time, time_t * morning, time_t * night);

/* server.c */

int do_accept(int acc_sock);
void send_to_all(char *string);
void cycle_on_connections(int accept_socket);
int init_server(void);

typedef struct {
    char *alias;
    char *description;
    char *process;
    char *group;
} x10module;

typedef struct {
    int mode;
    unsigned char once, thread, quiet;
    int repeat;
    time_t interval;
    time_t timestamp;
    int handle;
    char *script;
} event;

typedef struct _COMMANDLIST {
    char *command;
    char *process;
    struct _COMMANDLIST *parent, *child;
} COMMANDLIST;
